package ru.ccfit.inechakhin.pacman.Model;

public class Maze {
    private final int NX_BLOCKS = 26;
    private final int NY_BLOCKS = 29;

    private final short[] levelData = {
            19, 26, 26, 26, 26, 18, 26, 26, 26, 26, 26, 22,  0,  0, 19, 26, 26, 26, 26, 26, 18, 26, 26, 26, 26, 22,
            21,  0,  0,  0,  0, 21,  0,  0,  0,  0,  0, 21,  0,  0, 21,  0,  0,  0,  0,  0, 21,  0,  0,  0,  0, 21,
            21,  0,  0,  0,  0, 21,  0,  0,  0,  0,  0, 21,  0,  0, 21,  0,  0,  0,  0,  0, 21,  0,  0,  0,  0, 21,
            21,  0,  0,  0,  0, 21,  0,  0,  0,  0,  0, 21,  0,  0, 21,  0,  0,  0,  0,  0, 21,  0,  0,  0,  0, 21,
            17, 26, 26, 26, 26, 16, 26, 26, 18, 26, 26, 24, 26, 26, 24, 26, 26, 18, 26, 26, 16, 26, 26, 26, 26, 20,
            21,  0,  0,  0,  0, 21,  0,  0, 21,  0,  0,  0,  0,  0,  0,  0,  0, 21,  0,  0, 21,  0,  0,  0,  0, 21,
            21,  0,  0,  0,  0, 21,  0,  0, 21,  0,  0,  0,  0,  0,  0,  0,  0, 21,  0,  0, 21,  0,  0,  0,  0, 21,
            25, 26, 26, 26, 26, 20,  0,  0, 25, 26, 26, 22,  0,  0, 19, 26, 26, 28,  0,  0, 17, 26, 26, 26, 26, 28,
            0,  0,  0,  0,  0, 21,  0,  0,  0,  0,  0, 21,  0,  0, 21,  0,  0,  0,  0,  0, 21,  0,  0,  0,  0,  0,
            0,  0,  0,  0,  0, 21,  0,  0,  0,  0,  0, 21,  0,  0, 21,  0,  0,  0,  0,  0, 21,  0,  0,  0,  0,  0,
            0,  0,  0,  0,  0, 21,  0,  0, 19, 26, 26, 24, 18, 18, 24, 26, 26, 22,  0,  0, 21,  0,  0,  0,  0,  0,
            0,  0,  0,  0,  0, 21,  0,  0, 21,  0,  0,  0, 33, 36,  0,  0,  0, 21,  0,  0, 21,  0,  0,  0,  0,  0,
            0,  0,  0,  0,  0, 21,  0,  0, 21,  0, 35, 34, 32, 32, 34, 38,  0, 21,  0,  0, 21,  0,  0,  0,  0,  0,
            26, 26, 26, 26, 26, 16, 26, 26, 20,  0, 33, 32, 32, 32, 32, 36,  0, 17, 26, 26, 16, 26, 26, 26, 26, 26,
            0,  0,  0,  0,  0, 21,  0,  0, 21,  0, 41, 40, 40, 40, 40, 44,  0, 21,  0,  0, 21,  0,  0,  0,  0,  0,
            0,  0,  0,  0,  0, 21,  0,  0, 21,  0,  0,  0,  0,  0,  0,  0,  0, 21,  0,  0, 21,  0,  0,  0,  0,  0,
            0,  0,  0,  0,  0, 21,  0,  0, 17, 26, 26, 26, 26, 26, 26, 26, 26, 20,  0,  0, 21,  0,  0,  0,  0,  0,
            0,  0,  0,  0,  0, 21,  0,  0, 21,  0,  0,  0,  0,  0,  0,  0,  0, 21,  0,  0, 21,  0,  0,  0,  0,  0,
            0,  0,  0,  0,  0, 21,  0,  0, 21,  0,  0,  0,  0,  0,  0,  0,  0, 21,  0,  0, 21,  0,  0,  0,  0,  0,
            19, 26, 26, 26, 26, 16, 26, 26, 24, 26, 26, 22,  0,  0, 19, 26, 26, 24, 26, 26, 16, 26, 26, 26, 26, 22,
            21,  0,  0,  0,  0, 21,  0,  0,  0,  0,  0, 21,  0,  0, 21,  0,  0,  0,  0,  0, 21,  0,  0,  0,  0, 21,
            21,  0,  0,  0,  0, 21,  0,  0,  0,  0,  0, 21,  0,  0, 21,  0,  0,  0,  0,  0, 21,  0,  0,  0,  0, 21,
            25, 26, 22,  0,  0, 17, 26, 26, 18, 26, 26, 24, 26, 26, 24, 26, 26, 18, 26, 26, 20,  0,  0, 19, 26, 28,
            0,  0, 21,  0,  0, 21,  0,  0, 21,  0,  0,  0,  0,  0,  0,  0,  0, 21,  0,  0, 21,  0,  0, 21,  0,  0,
            0,  0, 21,  0,  0, 21,  0,  0, 21,  0,  0,  0,  0,  0,  0,  0,  0, 21,  0,  0, 21,  0,  0, 21,  0,  0,
            19, 26, 24, 26, 26, 28,  0,  0, 25, 26, 26, 22,  0,  0, 19, 26, 26, 28,  0,  0, 25, 26, 26, 24, 26, 22,
            21,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, 21,  0,  0, 21,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, 21,
            21,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, 21,  0,  0, 21,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, 21,
            25, 26, 26, 26, 26, 26, 26, 26, 26, 26, 26, 24, 26, 26, 24, 26, 26, 26, 26, 26, 26, 26, 26, 26, 26, 28,
    };

    private final short[] screenData = new short[NX_BLOCKS * NY_BLOCKS];

    public int getBLOCK_SIZE () {
        return 24;
    }

    public int getNX_BLOCKS () {
        return NX_BLOCKS;
    }

    public int getNY_BLOCKS () {
        return NY_BLOCKS;
    }

    public short getElemScreenData (int index) {
        return screenData[index];
    }

    public void setElemScreenData (int index, short elem) {
        screenData[index] = elem;
    }

    public short[] getScreenData () {
        return screenData;
    }

    public void setStartScreenData () {
        System.arraycopy(levelData, 0, screenData, 0, NX_BLOCKS * NY_BLOCKS);
    }

    public boolean isFinished () {
        for (int i = 0; i < NX_BLOCKS * NY_BLOCKS; ++i) {
            if (screenData[i] >= 16 && screenData[i] < 32) {
                return false;
            }
        }
        return true;
    }

}
